### Method

# FwupdPlugin DeviceEvent copy_data

since: 2.0.0

#### Declaration [src]

    gboolean
    fu_device_event_copy_data (
      FuDeviceEvent* self,
      const gchar* key,
      guint8* buf,
      gsize bufsz,
      gsize* actual_length,
      GError** error
    )

#### Description [src]

Copies memory from the event.

Available since: 2.0.0

#### Parameters

`key`

  Type: `const gchar*`

  A unique key, e.g. `Name`.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`buf`

  Type: `guint8*`

  A buffer.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`bufsz`

  Type: `gsize`

  Size of `buf`.

`actual_length`

  Type: `gsize*`

  The actual number of bytes sent, or `NULL`.

  The argument will be set by the function.
  The argument can be `NULL`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if the buffer was copied.